var disabled=false;

function disableForm()
{
    var anchors = document.getElementsByTagName('a');
    for (var i=0; i< anchors.length; ++i)
    {
        anchors[i].removeAttribute('href');
    }
    for (var i=0; i<document.forms.length; ++i)
    {
        for (var j=0; j<document.forms[i].elements.length; j++)
        {
            document.forms[i].elements[j].disabled="true";
        }
    }

    disabled=true;
}

function logout()
{
    WinManager.confirmLogout(window);
}

function openPage(page, pageName, configuration) {
    if (configuration == '' || configuration == null)
    {
        window.open(page, pageName, config='toolbar=yes, menubar=no, directories=no, scrollbars=yes, resizable=yes, status=yes');
    }
    else
    {
        window.open(page, pageName, config=configuration);
    }
}

function blockEnter(e)
{
    var keycode;
    if (window.event)
        keycode = window.event.keyCode;
    else if (e)
        keycode = e.which;
    else if (blockEnter.caller.arguments[0])
        keycode = blockEnter.caller.arguments[0].which;
    else
        return true;

    if (keycode == 13)
        return false;
    else
        return true;
}


//---------------------------------------------------------------------------------------------
//              Start of XML/DOM related util methods
//   (some of these functions require the Sarissa library to be available)
//---------------------------------------------------------------------------------------------


/**
 * Returns an XML document from the contents of a textarea with a given id
 * @param id The ID of the textarea containing the XML content
 */
function getXMLIsland(id)
{
    var island = document.getElementById(id);
    if ((island != null) && (island.value != ''))
    {
        return getXMLDocument(island.value);
    }
    return null;
}


/**
 * Returns a new DOM document, optionally created from the given content
 * @param docContent (optional) parameter indicating the content that should be placed in the new document
 *          This can be either a string containing the XML content, or an XML node.
 * @return The created document.
 */
function getXMLDocument(docContent)
{
    //alert('creating document ' + typeof(docContent));
    if (typeof(docContent) != 'undefined')
    {
        if (typeof(docContent) == 'string')
        {
            //alert('source string: ' + docContent);
            return (new DOMParser()).parseFromString(docContent, "text/xml");
        }
        else
            return (new DOMParser()).parseFromString(new XMLSerializer().serializeToString(docContent), "text/xml");
    }
    else
    {
        var doc = Sarissa.getDomDocument();
        doc.resolveExternals = false;
        doc.validateOnParse = false;
        doc.async = false;
        return doc;
    }
}

/**
 * Returns an XML document created from the content at the specified URL.
 * This is a synchronous load, so should not be used if the URL call could take some time.
 * @param url The URL of the XML content to load.
 */
function getXMLDocumentFromURL(url, processedFiles)
{
    var doc;
    try  //this should work in IE, FF, etc
    {
        doc = getXMLDocument();
        doc.load(url)
    }
    catch (e)
    { //this is needed for google chrome
       var xmlhttp = new window.XMLHttpRequest();
       xmlhttp.open("GET", url, false);
       xmlhttp.send(null);
       doc = getXMLDocument(xmlhttp.responseText);

       //Google chrome does not support includes/imports in XSLs
       //Therefore we try and manually combine all these into one XSL
       //It is not possible to do this completely, but for simple template/variable overrides
       //this should work okay.
       //Once google fix the bug, we can probably remove this code
       //See http://code.google.com/p/chromium/issues/detail?id=8441
       if (typeof(processedFiles) == 'undefined')
           var processedFiles = new Object();

       var baseURL = '';
       if (url.indexOf('/') != -1)
       {
           baseURL = url.substring(0, url.lastIndexOf('/'));
       }

       processXSLIncludesInLoadedDoc(doc, baseURL, processedFiles);
    }
    return doc;
}


function processXSLIncludesInLoadedDoc(doc, baseURL, processedFiles)
{
    Sarissa.setXpathNamespaces(doc, 'xmlns:xsl="http://www.w3.org/1999/XSL/Transform"');
    var imports = doc.selectNodes("/xsl:stylesheet/xsl:import|/xsl:stylesheet/xsl:include");

    for (var i = 0; i < imports.length; ++i)
    {
        var fileName = imports.item(i).getAttribute('href');
        if (baseURL != '')
            fileName = baseURL + '/' + fileName;

        //remove the import form the document
        imports.item(i).parentNode.removeChild(imports.item(i));

        if (!processedFiles[fileName])
        {
            processedFiles[fileName] = true;
            //load up the new file
            var loadedFile = getXMLDocumentFromURL(fileName, processedFiles);
            Sarissa.setXpathNamespaces(loadedFile, 'xmlns:xsl="http://www.w3.org/1999/XSL/Transform"');
            //check for global variables to include
            var variables = loadedFile.selectNodes("/xsl:stylesheet/xsl:variable");
            for (var j = 0; j < variables.length; ++j)
            {
                var varName = variables.item(j).getAttribute('name');
                if (doc.selectSingleNode("/xsl:stylesheet/xsl:variable[@name = '"+varName+"']") == null)
                {
                    var imported = variables.item(j);
                    if (typeof(doc.importNode) == 'function')
                        imported = doc.importNode(imported, true);

                    doc.documentElement.appendChild(imported);
                }
            }

            //check for any template matches to include
            var templates = loadedFile.selectNodes("/xsl:stylesheet/xsl:template[@match]");
            for (var j = 0; j < templates.length; ++j)
            {
                var templateMatch = templates.item(j).getAttribute('match');
                var templateMode = templates.item(j).getAttribute('mode');
                if (templateMode == null)
                {
                    if (doc.selectSingleNode("/xsl:stylesheet/xsl:template[(@match = '"+templateMatch+"') and not(@mode)]") == null)
                    {
                        var imported = templates.item(j);
                        if (typeof(doc.importNode) == 'function')
                            imported = doc.importNode(imported, true);

                        doc.documentElement.appendChild(imported);
                    }
                }
                else
                {
                    if (doc.selectSingleNode("/xsl:stylesheet/xsl:template[(@match = '"+templateMatch+"') and @mode = '" + templateMode + "']") == null)
                    {
                        var imported = templates.item(j);
                        if (typeof(doc.importNode) == 'function')
                            imported = doc.importNode(imported, true);

                        doc.documentElement.appendChild(imported);
                    }
                }
            }

            //check for any named tempaltes to include
            templates = loadedFile.selectNodes("/xsl:stylesheet/xsl:template[@name and not(@match)]");
            for (var j = 0; j < templates.length; ++j)
            {
                var templateName = templates.item(j).getAttribute('name');
                if (doc.selectSingleNode("/xsl:stylesheet/xsl:template[@name = '"+templateName+"']") == null)
                {
                    var imported = templates.item(j);
                    if (typeof(doc.importNode) == 'function')
                        imported = doc.importNode(imported, true);

                    doc.documentElement.appendChild(imported);
                }
            }
        }
    }
}

/**
 * Serializes the provided node to an XML string
 * @param xmlNode the node to serialize.
 * @return The XML formatted string.
 */
function xmlToString(xmlNode)
{
    if (xmlNode == null)
        return '';

    var xmlString = new XMLSerializer().serializeToString(xmlNode);
    //remove the xml declaration if present
    if (xmlString.match(/^(\s*)(<\?xml)/))
    {
        xmlString = xmlString.substr(xmlString.indexOf('>') + 1);
    }
    return xmlString;
}

/**
 * Returns the text content of the given xml element.
 * This just handles the browser differences in how this data should be found
 * @param elem The DOM Element to get the text content for.
 * @return The text content.
 */
function getElementText(elem)
{
    //special handling for attribute nodes
    //generally you are better of using the element.getAttribute method
    //to get the value of an attribute, but this is here to handle the case
    //where an atttribute node has been passed in.
    //Firefox 14 stopped the ability to get child text nodes of an attribute
    //so the general handling below no longer works!
    if (elem.nodeType == 2)
    {
        if (elem.value)
            return elem.value;
        else if (elem.nodeValue)
            return elem.nodeValue
    }


    var contents = '';
    if (elem != null)
    {
        var childNodes = elem.childNodes;

        for (var i = 0; i < childNodes.length; ++i)
        {
            if (childNodes.item(i).nodeType == 3)  //text node
            {
                contents += childNodes.item(i).nodeValue;
            }
        }
    }

    return contents;
}

/**
 * Sets the text content of the given element.
 * All existing child nodes of the element are removed.
 * @param elem The DOM element to set the text content of.
 * @param text The string specifying the text to use.
 */
function setElementText(elem, text)
{
    if (elem == null)
        return

    //special handling for attribute nodes
    //generally you are better of using the element.setAttribute method
    //to get the value of an attribute, but this is here to handle the case
    //where an atttribute node has been passed in.
    if (elem.nodeType == 2)
    {
        if (elem.value)
        {
            elem.value = text;
            return;
        }
        else if (elem.nodeValue)
        {
            elem.nodeValue = text;
            return;
        }
    }

    while(elem.hasChildNodes())
    {
        elem.removeChild(elem.firstChild);
    }

    elem.appendChild(elem.ownerDocument.createTextNode(text));
}


/**
 * Convenience function to return the base name (local name)
 * of the given element.  This just works out which property
 * to use to handle browser differences.
 */
function getBaseName(elem)
{
    if (elem == null) return null;
    if (elem.localName)
        return elem.localName;
    else if (elem.baseName) //MSXML
        return elem.baseName;
    else
        return elem.nodeName //fallback
}

/**
 * Returns a new element created with the given name, and namespace
 * by the provided document.
 * this just extracts away the browser specific issues of whether to use createElementNS
 * or createNode
 * @param doc The document to create the element in
 * @param name The name ot give the new element
 * @param ns The namespace URI to assign to the new element
 */
function createNamespaceElement(doc, name, ns)
{
    if (typeof(doc.createElementNS) != 'undefined') //W3C standard method
    {
        //alert('using w3c method');
        return doc.createElementNS(ns, name);
    }
    else if (typeof(doc.createNode) != 'undefined') //MSXML method
    {
        //alert('creating msxml element. ' + name + ', ' + ns);
        return doc.createNode('element', name, ns);
    }
    else
        return null;
}

/**
 * Returns the closest previous sibling to the given element
 * that is an element node. ie text nodes are ignored
 */
function getPreviousElementSibling(elem)
{
    var prev = elem.previousSibling;
    //make sure we return an element type node, not a text node
    while (prev && prev.nodeType != 1)
    {
        prev = prev.previousSibling;
    }

    return prev;
}

/**
 * Returns the closest folowing sibling to the given element
 * that is an element node. ie text nodes are ignored
 */
function getNextElementSibling(elem)
{
    var prev = elem.nextSibling;
    //make sure we return an element type node, not a text node
    while (prev && prev.nodeType != 1)
    {
        prev = prev.nextSibling;
    }

    return prev;
}
